#!/usr/bin/env python
import os, sys

Huge = 1.0e+10
out_fold = './figures'
problems = ['lr','lrb','svm']

lr_log_fold = './logLR'
lrb_log_fold = './logLRb'
svm_log_fold = './logSVM'
log_fold = {'lr':lr_log_fold,\
			'lrb':lrb_log_fold,\
			'svm':svm_log_fold}

lr_solver_list = ['BBR','CDN','SCD','TRON','OWL-QN','BMRM']
lrb_solver_list = ['CDN','CGD-GS','IPM','Lassplore','GLMNET']
svm_solver_list = ['CDN-NS','CDN','TRON','BMRM']
solver_list = {'lr':lr_solver_list,\
			   'lrb':lrb_solver_list,\
			   'svm':svm_solver_list}

fopt_refer_list = {'lr':'TRON',\
				  'lrb':'IPM',\
				  'svm':'TRON'}

gnorm_refer_list = {'lr':'CDN',\
					'lrb':'CDN',\
					'svm':'CDN'}

data_nick = {'leu.scale':'leu','duke.scale':'duke','a9a':'a9a',\
			 'real-sim':'real','news20.binary':'news',\
			 'rcv1_test.binary':'rcv1',\
			 'train308.scale':'japan','leisure.scale':'korea'}

# The best parameter C is selected by 5-fold cross-validation
bestC = {}
#bestC[('leu.scale','lr')] = 4.0
#bestC[('duke.scale','lr')] = 64.0
bestC[('a9a','lr')] = 4.0
bestC[('real-sim','lr')] = 4.0
bestC[('news20.binary','lr')] = 64.0
bestC[('rcv1_test.binary','lr')] = 4.0
bestC[('train308.scale','lr')] = 4.0
bestC[('leisure.scale','lr')] = 4.0

#bestC[('leu.scale','lrb')] = 2.0
#bestC[('duke.scale','lrb')] = 2.0
bestC[('a9a','lrb')] = 2.0
bestC[('real-sim','lrb')] = 4.0
bestC[('news20.binary','lrb')] = 64.0
bestC[('rcv1_test.binary','lrb')] = 4.0
bestC[('train308.scale','lrb')] = 4.0
bestC[('leisure.scale','lrb')] = 4.0

#bestC[('leu.scale','svm')] = 16.0
#bestC[('duke.scale','svm')] = 16.0
bestC[('a9a','svm')] = 0.5
bestC[('real-sim','svm')] = 1.0
bestC[('news20.binary','svm')] = 64.0
bestC[('rcv1_test.binary','svm')] = 1.0
bestC[('train308.scale','svm')] = 1.0
bestC[('leisure.scale','svm')] = 1.0

PLOT = {}
PLOT['obj1'] = 0
PLOT['obj2'] = 1
PLOT['acc'] = 1
PLOT['nr0'] = 1
PLOT['gnorm'] = 1

'ylabelcode,axistype,xmin,xmax,ymin,ymax'
obj1_code = '0,2,0,0,0,0'
obj2_code = '0,3,0,0,0,0'
acc_code  = '1,1,0,0,0,0'
nr0_code  = '2,1,0,0,0,0'
gnorm_code = '4,3,0,0,0,0'

obj1_code_table = {}
obj2_code_table = {}
acc_code_table  = {}
nr0_code_table  = {}
gnorm_code_table = {}

#XXX lr
obj1_code_table[('a9a','lr')]  = '0,2,0,1,0.00001,2'
obj1_code_table[('real','lr')] = '0,2,0,5,0.0001,10'
obj1_code_table[('news','lr')] = '0,2,0,10,0.0001,50'
obj1_code_table[('rcv1','lr')] = '0,2,0,100,0.0001,20'
obj1_code_table[('japan','lr')] = '0,2,0,40,0.0001,5'
obj1_code_table[('korea','lr')] = '0,2,0,300,0.0001,5'

obj2_code_table[('a9a','lr')]  = '0,3,0.1,50,0.00001,2'
obj2_code_table[('real','lr')] = '0,3,0.3,100,0.0001,10'
obj2_code_table[('news','lr')] = '0,3,1,500,0.0001,50'
obj2_code_table[('rcv1','lr')] = '0,3,5,5000,0.0001,20'
obj2_code_table[('japan','lr')] = '0,3,2,2000,0.0001,5'
obj2_code_table[('korea','lr')] = '0,3,10,20000,0.0001,5'

acc_code_table[('a9a','lr')]  = '1,1,0.04,200,0.845,0.851'
acc_code_table[('real','lr')] = '1,1,0.4,40,0.964,0.974'
acc_code_table[('news','lr')] = '1,1,1,400,0.935,0.965'
acc_code_table[('rcv1','lr')] = '1,1,6,5000,0.97,0.979'
acc_code_table[('japan','lr')] = '1,1,2,2000,0.91,0.928'
acc_code_table[('korea','lr')] = '1,1,20,100000,0.84,0.88'

nr0_code_table[('a9a','lr')]  = '2,1,0.04,200,80,140'
nr0_code_table[('real','lr')] = '2,1,0.7,100,3300,4200'
nr0_code_table[('news','lr')] = '2,1,1,1000,2300,4500'
nr0_code_table[('rcv1','lr')] = '2,1,20,10000,10800,12000'
nr0_code_table[('japan','lr')] = '2,1,1,10000,10000,15000'
nr0_code_table[('korea','lr')] = '2,1,4,1000000,28000,40000'

gnorm_code_table[('a9a','lr')]  = '4,3,0.1,50,0.0001,10'
gnorm_code_table[('real','lr')] = '4,3,0.3,100,0.000001,100'
gnorm_code_table[('news','lr')] = '4,3,1,1000,0.000001,100'
gnorm_code_table[('rcv1','lr')] = '4,3,5,10000,0.000001,10'
gnorm_code_table[('japan','lr')] = '4,3,2,10000,0.000001,100'
gnorm_code_table[('korea','lr')] = '4,3,10,1000000,0.000001,100'

#XXX lrb
obj2_code_table[('a9a','lrb')]  = '0,3,0,100,0.0001,1'
obj2_code_table[('real','lrb')] = '0,3,0.3,1000,0.0001,10'
obj2_code_table[('news','lrb')] = '0,3,0.5,20000,0.0001,30'
obj2_code_table[('rcv1','lrb')] = '0,3,5,100000,0.0001,20'
obj2_code_table[('japan','lrb')] = '0,3,2,1000,0.0001,2'
obj2_code_table[('korea','lrb')] = '0,3,15,10000,0.0001,2'

acc_code_table[('a9a','lrb')]  = '1,1,0.03,200,0.840,0.852'
acc_code_table[('real','lrb')] = '1,1,1,1000,0.966,0.974'
acc_code_table[('news','lrb')] = '1,1,1,20000,0.90,0.975'
acc_code_table[('rcv1','lrb')] = '1,1,7,20000,0.972,0.979'
acc_code_table[('japan','lrb')] = '1,1,10,500,0.914,0.93'
acc_code_table[('korea','lrb')] = '1,1,100,10000,0.84,0.88'

nr0_code_table[('a9a','lrb')]  = '2,1,0.05,200,70,140'
nr0_code_table[('real','lrb')] = '2,1,1,1000,2000,5000'
nr0_code_table[('news','lrb')] = '2,1,4,100000,2400,3400'
nr0_code_table[('rcv1','lrb')] = '2,1,8,200000,6000,18000'
nr0_code_table[('japan','lrb')] = '2,1,10,500,6000,12000'
nr0_code_table[('korea','lrb')] = '2,1,50,10000,10000,50000'

gnorm_code_table[('a9a','lrb')]  = '4,3,0.1,50,0.0001,10'
gnorm_code_table[('real','lrb')] = '4,3,0.3,100,0.000001,100'
gnorm_code_table[('news','lrb')] = '4,3,1,1000,0.000001,100'
gnorm_code_table[('rcv1','lrb')] = '4,3,5,10000,0.000001,10'
gnorm_code_table[('japan','lrb')] = '4,3,2,10000,0.000001,100'
gnorm_code_table[('korea','lrb')] = '4,3,10,1000000,0.000001,100'

#XXX svm
obj2_code_table[('a9a','svm')]  = '0,3,0.01,30,0.000001,1'
obj2_code_table[('real','svm')] = '0,3,0.05,20,0.0001,10'
obj2_code_table[('news','svm')] = '0,3,1,10000,0.0001,20'
obj2_code_table[('rcv1','svm')] = '0,3,1,1000,0.0001,20'
obj2_code_table[('japan','svm')] = '0,3,0,4000,0.0001,2'
obj2_code_table[('korea','svm')] = '0,3,1,90000,0.0001,2'

acc_code_table[('a9a','svm')]  = '1,1,0.008,40,0.841,0.851'
acc_code_table[('real','svm')] = '1,1,0.1,20,0.962,0.974'
acc_code_table[('news','svm')] = '1,1,1,10000,0.92,0.97'
acc_code_table[('rcv1','svm')] = '1,1,1,1000,0.97,0.979'
acc_code_table[('japan','svm')] = '1,1,1,500,0.91,0.93'
acc_code_table[('korea','svm')] = '1,1,5,10000,0.85,0.88'

nr0_code_table[('a9a','svm')]  = '2,1,0.1,40,80,140'
nr0_code_table[('real','svm')] = '2,1,0.1,20,3000,6000'
nr0_code_table[('news','svm')] = '2,1,10,10000,3200,4200'
nr0_code_table[('rcv1','svm')] = '2,1,1,500,10000,20000'
nr0_code_table[('japan','svm')] = '2,1,1,3000,10000,20000'
nr0_code_table[('korea','svm')] = '2,1,5,10000,20000,50000'

gnorm_code_table[('a9a','svm')]  = '4,3,0.1,50,0.0001,10'
gnorm_code_table[('real','svm')] = '4,3,0.3,100,0.000001,100'
gnorm_code_table[('news','svm')] = '4,3,1,1000,0.000001,100'
gnorm_code_table[('rcv1','svm')] = '4,3,5,10000,0.000001,10'
gnorm_code_table[('japan','svm')] = '4,3,2,10000,0.000001,100'
gnorm_code_table[('korea','svm')] = '4,3,10,1000000,0.000001,100'

STYLE = {'CDN':'-r*','BBR':'--g.','TRON':':b.','BMRM':'-.k.',\
		 'CDN-NS':'-c.','CGD-GS':'--g.','IPM':':b.','GLMNET':'-.k.',\
		 'SCD':'-m.','OWL-QN':'-c.','Lassplore':'-y.'}
LEGEND = {'CDN':'CDN','BBR':'BBR','TRON':'TRON','BMRM':'BMRM',\
		  'CDN-NS':'CDN-NS','CGD-GS':'CGD-GS','IPM':'IPM','GLMNET':'GLMNET',\
		  'SCD':'SCD','OWL-QN':'OWL-QN','Lassplore':'Lassplore'}

def figure(problem='lr'):
	where = log_fold[problem]
	whos = solver_list[problem]
	frefer = fopt_refer_list[problem]
	grefer = gnorm_refer_list[problem]
	legends = ','.join(map(lambda one: "'"+LEGEND[one]+"'", whos))
	linestyles = ','.join(map(lambda one: "'"+STYLE[one]+"'", whos))

	for key in bestC.keys():
		if key[1] != problem:
			continue
		which = key[0]
		nick = data_nick[which]
		C = bestC[(which,problem)]

		ginit = 1
		ginitlog = '%s/%s_%s_%s.log' %(where,grefer,which,C)
		if os.path.exists(ginitlog):
			fp = open(ginitlog, 'r')
			lst = fp.readline().strip().split();
			ginit = float(lst[lst.index('scale')+1])
			fp.close()
		else:
			print '-------------------------------------'
			print 'WARNING:', ginitlog, 'does not exist!'
			print '-------------------------------------'

		(obj,nr0) = (Huge,0)
		foptlog = '%s/%s_%s_%s.log' %(where,frefer,which,C)
		if os.path.exists(foptlog):
			fp = open(foptlog, 'r')
			for line in fp:
				if line.endswith('\n') and\
				   line.find('time')!=-1 and line.find('f')!=-1 and\
				   line.find('accuracy')!=-1 and line.find('nonzero')!=-1 and\
				   line.find('Gnorm')!=-1:
					lst = line.strip().split()
					tmpobj = float(lst[lst.index('f')+1])
					tmpnr0 = int(lst[lst.index('nonzero')+1])
					assert tmpobj>0 and tmpnr0>=0
					if tmpobj < obj:
						obj = tmpobj
						nr0 = tmpnr0
			fp.close()
		else:
			print '-----------------------------------'
			print 'WARNING:', foptlog, 'does not exist!'
			print '-----------------------------------'
			(obj,nr0) = (0,0)

		for one in whos:
			onelog = '%s/%s_%s_%s.log' %(where,one,which,C)
			if not os.path.exists(onelog):
				print '-----------------------------------'
				print 'WARNING:', onelog, 'does not exist!'
				print '-----------------------------------'
				obj_out = open('./tmp/%s.obj'%one, 'w')
				acc_out = open('./tmp/%s.acc'%one, 'w')
				nr0_out = open('./tmp/%s.nr0'%one, 'w')
				gnorm_out = open('./tmp/%s.gnorm'%one,'w')
				obj_out.write('0\t0\n')
				acc_out.write('0\t0\n')
				nr0_out.write('0\t0\n')
				gnorm_out.write('0\t0\n')
				obj_out.close()
				acc_out.close()
				nr0_out.close()
				gnorm_out.close()
				continue

			print onelog
			fp = open(onelog, 'r')
			obj_out = open('./tmp/%s.obj'%one, 'w')
			acc_out = open('./tmp/%s.acc'%one, 'w')
			nr0_out = open('./tmp/%s.nr0'%one, 'w')
			gnorm_out = open('./tmp/%s.gnorm'%one,'w')
			(lasttime,lastobj) = (1.0e-6,Huge)
			linecount = 0
			for line in fp:
				if line.endswith('\n') and\
				   line.find('time')!=-1 and line.find('f')!=-1 and\
				   line.find('accuracy')!=-1 and line.find('nonzero')!=-1 and\
				   line.find('Gnorm')!=-1:				   
					lst = line.strip().split()
					ff = float(lst[lst.index('f')+1])
					if ff>lastobj or ff<=0: continue
					tt = float(lst[lst.index('time')+1])
					tt = max(tt,lasttime)
					(lasttime,lastobj) = (tt,ff)
					try:
						ff = max(0.0, (ff-obj)/obj)
					except:
						pass
					aa = float(lst[lst.index('accuracy')+1])
					nn = float(lst[lst.index('nonzero')+1])
					gg = float(lst[lst.index('Gnorm')+1])/ginit
					assert tt>0 and ff>=0 and aa>=0 and nn>=0 and gg>0
					obj_line = '%s\t%s\n' %(tt,ff)
					acc_line = '%s\t%s\n' %(tt,aa)
					nr0_line = '%s\t%s\n' %(tt,nn)
					gnorm_line = '%s\t%s\n' %(tt,gg)
					obj_out.write(obj_line)
					acc_out.write(acc_line)
					nr0_out.write(nr0_line)
					gnorm_out.write(gnorm_line)
					linecount += 1
			fp.close()
			obj_out.close()
			acc_out.close()
			nr0_out.close()
			gnorm_out.close()

			if linecount==0:
				obj_out = open('./tmp/%s.obj'%one, 'w')
				acc_out = open('./tmp/%s.acc'%one, 'w')
				nr0_out = open('./tmp/%s.nr0'%one, 'w')
				gnorm_out = open('./tmp/%s.gnorm'%one, 'w')
				obj_out.write('0\t0\n')
				acc_out.write('0\t0\n')
				nr0_out.write('0\t0\n')
				gnorm_out.write('0\t0\n')
				obj_out.close()
				acc_out.close()
				nr0_out.close()
				gnorm_out.close()

		nick = data_nick[which]
		obj1_code = '0,2,0,0,0,0'
		obj2_code = '0,3,0,0,0,0'
		acc_code  = '1,1,0,0,0,0'
		nr0_code  = '2,1,0,0,0,0'
		gnorm_code = '4,3,0,0,0,0'

		# obj1
		outfile = '%s/%s_%s_obj1' % (out_fold,problem,nick)
		infiles = ','.join(map(lambda one: "'./tmp/"+one+".obj'", whos))
		if obj1_code_table.has_key((nick,problem)):
			obj1_code = obj1_code_table[(nick,problem)]
		cmd = \
'''matlab -r "addpath('tools'); outfile='%s'; infiles={%s}; legends={%s}; linestyles={%s}; draw(outfile, infiles, linestyles, legends, %s, 0); quit;" >./tmp/log.log
''' % (outfile,infiles,legends,linestyles,obj1_code)
		if PLOT['obj1']:
			print cmd
			os.system(cmd)

		# obj2
		outfile = '%s/%s_%s_obj2' % (out_fold,problem,nick)
		infiles = ','.join(map(lambda one: "'./tmp/"+one+".obj'", whos))
		if obj2_code_table.has_key((nick,problem)):
			obj2_code = obj2_code_table[(nick,problem)]
		cmd = \
'''matlab -r "addpath('tools'); outfile='%s'; infiles={%s}; legends={%s}; linestyles={%s}; draw(outfile, infiles, linestyles, legends, %s, 0.01); quit;" >>./tmp/log.log
''' % (outfile,infiles,legends,linestyles,obj2_code)
		if PLOT['obj2']:
			print cmd
			os.system(cmd)

		# acc
		outfile = '%s/%s_%s_acc' % (out_fold,problem,nick)
		infiles = ','.join(map(lambda one: "'./tmp/"+one+".acc'", whos))
		if acc_code_table.has_key((nick,problem)):
			acc_code = acc_code_table[(nick,problem)]
		cmd = \
'''matlab -r "addpath('tools'); outfile='%s'; infiles={%s}; legends={%s}; linestyles={%s}; draw(outfile, infiles, linestyles, legends, %s, 0); quit;" >>./tmp/log.log
''' % (outfile,infiles,legends,linestyles,acc_code)
		if PLOT['acc']:
			print cmd
			os.system(cmd)

		# nr0
		outfile = '%s/%s_%s_nr0' % (out_fold,problem,nick)
		infiles = ','.join(map(lambda one: "'./tmp/"+one+".nr0'", whos))
		if nr0_code_table.has_key((nick,problem)):
			nr0_code = nr0_code_table[(nick,problem)]
		cmd = \
'''matlab -r "addpath('tools'); outfile='%s'; infiles={%s}; legends={%s}; linestyles={%s}; draw(outfile, infiles, linestyles, legends, %s, %d); quit;" >>./tmp/log.log
''' % (outfile,infiles,legends,linestyles,nr0_code,nr0)
		if PLOT['nr0']:
			print cmd
			os.system(cmd)

		# gnorm
		outfile = '%s/%s_%s_gnorm'%(out_fold,problem,nick)
		infiles = ','.join(map(lambda one: "'./tmp/"+one+".gnorm'",whos))
		if gnorm_code_table.has_key((nick,problem)):
			gnorm_code = gnorm_code_table[(nick,problem)]
		cmd = \
'''matlab -r "addpath('tools'); outfile='%s'; infiles={%s}; legends={%s}; linestyles={%s}; draw(outfile, infiles, linestyles, legends, %s, 0); quit;" >>./tmp/log.log
''' % (outfile,infiles,legends,linestyles,gnorm_code)
		if PLOT['gnorm']:
			print cmd
			os.system(cmd)


if __name__ == '__main__':
	if len(sys.argv) > 1:
		assert sys.argv[1] in problems
		figure(sys.argv[1])
	else:
		figure()

