#!/usr/bin/env python
import os, sys

# libsvmtool web page
web_link = 'http://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/'

# path of yahoo-japan & yahoo-korea
data_path = '~/data/'

# Set data paths in web_link
# Comment it, if you do not run it.
data_dict = {}
#data_dict['leu'] = 'leu.bz2'
#data_dict['duke'] = 'duke.bz2'
data_dict['a9a'] = 'a9a'
data_dict['real-sim'] = 'real-sim.bz2'
data_dict['news20'] = 'news20.binary.bz2'
#data_dict['rcv1'] = 'rcv1_test.binary.bz2'
#data_dict['yahoo-japan'] = 'train308.scale'
#data_dict['yahoo-korea'] = 'leisure.scale'

# Keep the order of all data sets
all_data = ['leu','duke','a9a','real-sim',\
			'news20','rcv1','yahoo-japan','yahoo-korea']

# Build libsvmread.mex* & libsvmwrite.mex*
os.chdir('tools')
os.system('make all')
os.chdir('..')

# Download mmwrite.m
if not os.path.exists('tools/mmwrite.m'):
	os.system('wget -O tools/mmwrite.m http://math.nist.gov/MatrixMarket/mmio/matlab/mmwrite.m')

data_list = []
for data in all_data:
	if data in data_dict.keys():
		data_list.append(data)
print 'Ready to generate', ', '.join(data_list), '...'

for data in data_list:
	if not data.startswith('yahoo'):
		print '\n-------------------------------------'
		print 'Download', data_dict[data]
		link = '%s%s' %(web_link,data_dict[data])
		cmd = 'wget -O data/%s %s' %(data_dict[data],link)
		print cmd
		os.system(cmd)
	else:
		print '\n-------------------------------------'
		print 'Copy', data_dict[data], 'from', data_path
		path = os.path.join(data_path,data_dict[data])
		cmd = 'cp %s data/%s' %(path,data_dict[data])
		if not os.path.exists(path):
			print path, 'does not exist!!'
			continue
		else:
			print cmd
			os.system(cmd)

	if not os.path.exists('data/%s' %data_dict[data]):
		print 'Download failed!!'
		continue

	if data_dict[data].endswith('.bz2'):
		print '\n-------------------------------------'
		print 'Uncompress', data_dict[data]
		cmd = 'bunzip2 data/%s' %data_dict[data]
		print cmd
		os.system(cmd)
		data_file = data_dict[data][0:-4]

		if not os.path.exists('data/%s' %data_file):
			print 'Uncompress failed!!'
			continue
	else:
		data_file = data_dict[data]
		
	if data=='leu' or data=='duke':
		print '\n-------------------------------------'
		print 'Scale', data, 'to the range of [0,1]'
		cmd = 'matlab -nodisplay -r "cd tools;scale(\'../data/%s\');cd ..;quit;"' %data
		print cmd
		os.system(cmd)
		data_file = '%s.scale' %data

		if not os.path.exists('data/%s' %data_file):
			print 'Scale failed!!'
			continue

	print '\n-------------------------------------'
	print 'Count the size of', data_file
	cmd = 'wc -l data/%s' %data_file
	print cmd
	fp = os.popen(cmd)
	total_size = int(fp.readline().strip().split()[0])
	test_size = total_size/5
	train_size = total_size-test_size
	fp.close()
	print total_size

	print '\n-------------------------------------'
	print 'Do a 80/20 split for', data_file, '(',train_size,'/',test_size,')'
	test_data = '%s.test' %data_file
	train_data = '%s.train' %data_file
	cmd = 'python subset.py -s 2 data/%s %s data/%s.fix data/%s data/%s'\
		%(data_file,test_size,data_file,test_data,train_data)
	print cmd
	os.system(cmd)

	if not os.path.exists('data/%s' %test_data) or\
	   not os.path.exists('data/%s' %train_data):
		print 'Split failed!!'
		continue

	print '\n-------------------------------------'
	print 'Convert', test_data, 'and', train_data, 'to other data formats'
	cmd = 'matlab -nodisplay -r "cd tools;convert(\'../data/%s.test\');convert(\'../data/%s.train\');cd ..;quit;"'\
		%(data_file,data_file)
	print cmd
	os.system(cmd)


