% The script is used for the conversion of data format
% from libsvm to IPM, SCD and BMRM format.

function convert(filename)
disp(filename);

[Y,X] = libsvmread(filename);
l = size(X,1);
n = size(X,2);

% IPM
disp('Convert to IPM format');
Xfilename = sprintf('%s.ipm.x', filename);
Yfilename = sprintf('%s.ipm.y', filename);

% wget http://math.nist.gov/MatrixMarket/mmio/matlab/mmwrite.m
mmwrite(Xfilename, X)
mmwrite(Yfilename, Y)


% SCD
disp('Convert to SCD format');
Xfilename = sprintf('%s.scd.x', filename);
Yfilename = sprintf('%s.scd.y', filename);
Xfid = fopen(Xfilename, 'w');
Yfid = fopen(Yfilename, 'w');

fprintf(Xfid, '%d %d\n', l, n);

for j = 1:n
	x = X(:,j);
	if nnz(x)==0
		fprintf(Xfid, '0 0\n');
	else
		[row,col,val] = find(x);
		row = row-1;
		fprintf(Xfid, '%d %g', row(1),val(1));
		if nnz(x)>1
			fprintf(Xfid, ' %d %g', [row(2:end) val(2:end)]');
		end
		fprintf(Xfid, '\n');
	end
end

for i = 1:l
	yi = Y(i);
	assert(yi==1 || yi==-1);
	fprintf(Yfid, '%d\n', yi);
end

fclose(Xfid);
fclose(Yfid);



