#include <stdio.h>
#include <string.h>
#include <math.h>

#include "lr1_problem.h"
#include "externfuncs.h"
#include "misc.h"

#define SMALL_GAP 0

void trpcg(int n, int* indfree, lr1_problem* prob, double* g, double* D, double delta, double tol, double* s, int* itertr, int* infotr, double* wa2){

	int i, inc = 1;
	double one = 1;
	double *r = Malloc(double, n);
	double *d = Malloc(double, n);
	double *Hd = Malloc(double, n);
	double rTr, rnewTrnew, alpha, beta;
	double dHd;
	double *wa3 = Malloc(double, n);

	for (i=0; i<n; i++){
		s[i] = 0;
		r[i] = -g[i];
		d[i] = r[i];
	}

	*itertr = 0;
	rTr = ddot_(&n, r, &inc, r, &inc);
	while (1){
		if (dnrm2_(&n, r, &inc) <= tol){
			*infotr = 1;
			break;
		}
		(*itertr)++;
		prob->subHv(n, indfree, D, d, Hd);
		dHd = ddot_(&n, d, &inc, Hd, &inc);
		if(dHd >= SMALL_GAP){ //XXX what value should be set ? @@ 
			alpha = rTr/dHd;
			daxpy_(&n, &alpha, d, &inc, s, &inc);
		}
		else{
			alpha = 0;
		}

		memcpy(wa3, wa2, sizeof(double)*n);
		daxpy_(&n, &one, s, &inc, wa3, &inc);
		
		if (dnrm2_(&n, wa3, &inc) > delta || dHd < SMALL_GAP) {
			alpha = -alpha;
			daxpy_(&n, &alpha, d, &inc, s, &inc); //... 

			double std = ddot_(&n, s, &inc, d, &inc); 
			double sts = ddot_(&n, s, &inc, s, &inc);
			double dtd = ddot_(&n, d, &inc, d, &inc); 
			double dsq = delta*delta;
			double rad = sqrt(std*std + dtd*(dsq-sts));
			if (std >= 0)
				alpha = (dsq - sts)/(std + rad);
			else
				alpha = (rad - std)/dtd;
			daxpy_(&n, &alpha, d, &inc, s, &inc);
			/*XXX why calculate r ?
			alpha = -alpha; 
			daxpy_(&n, &alpha, Hd, &inc, r, &inc);		
			*/
			if(dHd < SMALL_GAP)
				*infotr = 3;
			else{
				*infotr = 4;
			}
			break;
		}
		alpha = -alpha; 
		daxpy_(&n, &alpha, Hd, &inc, r, &inc);		
		rnewTrnew = ddot_(&n, r, &inc, r, &inc);
		beta = rnewTrnew/rTr; 
		dscal_(&n, &beta, d, &inc);
		daxpy_(&n, &one, r, &inc, d, &inc);
		rTr = rnewTrnew;
	}
	free(d);
	free(wa3);
	free(Hd);
	free(r);

	return;
}

